<?php
/**
 * Example file for PEAR PHP_UML
 *
 * See also the screen captures obtained with those examples in various UML softwares.
 *
 * BEWARE : test_example2.xmi is generated in XMI version 2, so you can import it only
 * in a UML tool compatible with the version 2 of XMI (like Bouml)
 *
 * PHP version 5
 *
 * @category PHP
 * @package  PHP_UML
 * @author   Baptiste Autin <ohlesbeauxjours@yahoo.fr>
 *
 */

error_reporting(E_ALL);
require_once '../UML.php';


/**
 * Example 1 : Basic example with file "test.php"
 */

$t = new PHP_UML;

$t->parseFile('test1.php.txt', 'global');   // We parse the file "test.php", and the default namespace is 'global'
$t->generateXMI(1);                     // Generation of XMI in version 1
$t->saveXMI('test_example1.xmi');       // We save the XMI code



/**
 * Example 2 : Advanced example with files "test.php" and "test2.php"
 */

$t = new PHP_UML;

$t->dollar             = false;    // We don't keep the $ before the variable names
$t->componentView      = false;    // We don't want a component view to be included (subsystems and components)
$t->deploymentView     = true;     // We want a deployment view (artifacts and packages)
$t->docblocks          = true;     // We want the parser to look into the class / file comments
$t->ignoredDirectories = array();  // We want to scan all directories

// We parse "test.php.txt" and "test2.php.txt". The default namespace will be 'testModel':
$t->parseFile(array('test1.php.txt', 'test2.php.txt'), 'testModel');    
$t->generateXMI(2, 'utf-8');        // Generation of XMI in version 2
$t->saveXMI('test_example2.xmi');   // We save the XMI code in a file "test.xmi"
echo htmlentities($t->XMI);         // And we echo it.


/**
 * Example 3 : Example with the whole current directory
 */
 
$t = new PHP_UML;

$t->acceptedExtensions = array('php', 'txt');	// (the source files have a .txt extension, because they must be ignored by the online API auto-documentation of PEAR...)

$t->parseDirectory('./');
$t->generateXMI(1, 'iso-8859-1');
$t->saveXMI('test_example3.xmi');

echo 'Done !!';

?>
