<?php

/**
 * 
 * Test file for checking PHP namespaces a bit further
 *
 */


/**
 * That interface is defined in the global namespace:
 */
interface Livable() {
}

/**
 * @package PHP_UML::tests::SolarSystem::Planet
 */
class Sun extends PHP_UML::tests::SolarSystem::Star
				  implements PHP_UML::tests::SolarSystem::Planet::Spinable {

}

namespace PHP_UML::tests::SolarSystem;

class Star implements PHP_UML::tests::SolarSystem::Planet::Spinable {

}

/**
 * That interface implicitely creates a "Planet" package,
 * ... and puts itself into it
 */
interface PHP_UML::tests::SolarSystem::Planet::Spinable  {

}


namespace PHP_UML::tests::SecondSolarSystem;

class Star implements PHP_UML::tests::SolarSystem::Planet::Spinable {

}

use PHP_UML::tests::SolarSystem::Planet as P;

use PHP_UML::tests::SolarSystem::Planet as Q;

/**
 * That Venus class is in the namespace "SolarSystem" because of the previous instruction "namespace SolarSystem;"
 * It can realize "Spinable" (without prefix),  because of the "use SolarSystem::Planet"
 */
class Venus implements P::Spinable {
}

/**
 * That class can realize ::Livable because Livable was defined in the global namespace
 */
class Earth implements ::Livable, Q::Spinable {
}

/**
 * That class can realize "Spinable",  because of the "use SolarSystem::Planet as P;"
 */ 
class Moon implements P::Spinable  {
}


/*
 * To chech that a package like "PP" is not substituted by the "P" import:
 */
namespace PHP_UML::tests::PP;

class PeePee {
}

class PowPow extends PHP_UML::tests::PP::PeePee {
}

use PHP_UML::tests::SolarSystem;

class Comete extends SolarSystem::Star {
}

?>